SystemOrganization addCategory: #'PostMark-Tests'!

TestCase subclass: #PMEmailTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostMark-Tests'!

!PMEmailTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 17:20'!
testAccessors
	| email |
	email := PMEmail new.
	email from: 'francois@wapict.be'.
	email to: #('tulipe.moutarde@gmail.com' 'tulipe@yopmail.com').
	email subject: 'Hello!!'.
	email htmlBody: '<strong>Blop</strong>'.
	email textBody: 'Blop'.
	
	self assert: email textBody equals: 'Blop'.
	self assert: email subject equals: 'Hello!!'.! !

TestCase subclass: #PMInterfaceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostMark-Tests'!

!PMInterfaceTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 17:23'!
testAccessors
	| interface |
	interface  := PMInterface new.
	interface apiKey: 'KEY'.
	self assert: interface apiKey equals: 'KEY'.! !

!PMInterfaceTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 18:16'!
testDefaultValues
	| interface |
	interface := PMInterface new.
	self deny: interface developmentMode.
	interface debugStream: ('' writeStream).
	self assert: interface developmentMode.
	
	self assert: interface apiUrl equals: interface defaultApiUrl.! !

!PMInterfaceTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 21:21'!
testHandle404Response
	| interface response |
	interface := PMInterface new.
	response := ZnResponse notFound: 'http://blop.com/azert'.
	self 
		should: [ interface handleResponse: response ] 
		raise: PMException.! !

!PMInterfaceTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 21:33'!
testHandle422Response
	| interface response |
	interface := PMInterface new.
	response := ZnResponse new
		statusLine: (ZnStatusLine code: 422);
		entity: (ZnStringEntity new
			contentType: ZnMimeType applicationJson;
			string: '{"ErrorCode": 405, "Message": "Not allowed to send"}' ) ;
		yourself.
	self 
		should: [ interface handleResponse: response ] 
		raise: PMException.
	
	[ interface handleResponse: response]
		on: PMException
		do: [:e | self assert: (e messageText includesSubString: 'Not allowed to send')]
	
	! !

!PMInterfaceTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 21:15'!
testHandleSuccessResponse
	| interface response |
	interface := PMInterface new.
	response := ZnResponse ok: (ZnStringEntity text: '').
	self assert: (interface handleResponse: response).! !

!PMInterfaceTest methodsFor: 'testing' stamp: 'FrancoisStephany 12/15/2011 18:23'!
testSend
	| interface email |
	email := PMEmail new.
	email from: 'francois@wapict.be'.
	email to: #('tulipe.moutarde@gmail.com' 'tulipe@yopmail.com').
	email subject: 'Hello!!'.
	email htmlBody: '<strong>Blop</strong>'.
	email textBody: 'Blop'.
	
	interface := PMInterface new.
	self deny: interface developmentMode.
	interface debugStream: ('' writeStream).
	
	interface send: email.
	self assert: (Json render: email) equals: interface debugStream contents.! !
